## Struct impl

boost::log::attribute_value::impl — A base class for an attribute value implementation.

## Synopsis

    // In header: <boost/log/attributes/attribute_value.hpp>

    // A base class for an attribute value implementation.

    struct impl : public attribute::impl {

      // public member functions
      virtual bool dispatch(type_dispatcher &) = 0;
      virtual intrusive_ptr< impl > detach_from_thread();
      virtual attribute_value get_value();
      virtual type_info_wrapper get_type() const;
    };

## Description

All attribute value holders should derive from this interface.

### `impl` public member functions

1.     virtual bool dispatch(type_dispatcher & dispatcher) = 0;

   The method dispatches the value to the given object.

   Parameters:

   `dispatcher` | The object that attempts to dispatch the stored value.

   Returns: | true if dispatcher was capable to consume the real attribute value type and false otherwise.

2.     virtual intrusive_ptr< impl > detach_from_thread();

   The method is called when the attribute value is passed to another thread (e.g. in case of asynchronous logging). The value should ensure it properly owns all thread-specific data.

   Returns: | An actual pointer to the attribute value. It may either point to this object or another. In the latter case the returned pointer replaces the pointer used by caller to invoke this method and is considered to be a functional equivalent to the previous pointer.

3.     virtual attribute_value get_value();

   Returns: | The attribute value that refers to self implementation.

4.     virtual type_info_wrapper get_type() const;

   Returns: | The attribute value type